package components;

import cli.TraceLabSDK.*;
import cli.TraceLabSDK.Types.Generics.Collections.StringList;
import java.util.Scanner;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

@ComponentAttribute.Annotation(
        Name = "Add One",
        Description = "Reads integers from text file, adds one to each of those integers, and saves this to a new text file.",
        Author = "Hayes",
        Version = "1.0",
        ConfigurationType = Config.class)

@IOSpecAttribute.Annotation.__Multiple({
    @IOSpecAttribute.Annotation(IOType = IOSpecType.__Enum.Output, Name = "Contents",
            DataType = StringList.class)
        
})

@TagAttribute.Annotation("File Reader")

public class AddOne extends BaseComponent {
     private final Config config;
    public AddOne(ComponentLogger log) {
        super(log);
        config = new Config();
        super.set_Configuration(config);
    }
    
    @Override
    public void Compute() {
        super.get_Logger().Trace("Beginning file reader");
        int i=0;
        int list[] = new int[100];
        StringList values = new StringList();
        String intToString;
        
        String inputFile = config.getInputFile();
        String outputFile = config.getOutputFile();
        
        try{

            Scanner scanner = new Scanner(new File(inputFile));
 
            while(scanner.hasNextInt()){
                list[i] = scanner.nextInt();
                i++;
            }
       }
        
        catch(FileNotFoundException exception){
             super.get_Logger().Info(exception);
        }
       
        try{
            PrintWriter pw = new PrintWriter(outputFile);
            int newlist[] = new int[100];
             for(int j=0;j<i;j++){
                newlist[j] = list[j] + 1;
                intToString = String.valueOf(newlist[j]);   //Convert integer to string
                values.Add(intToString); //Add to values StringList
                pw.println(newlist[j]);               
                }  
        
        pw.close();     //Close output file
        super.get_Workspace().Store("Contents", values);    //Store value StringList to workspace
        } 

       catch(FileNotFoundException exception){
           super.get_Logger().Info(exception);
       }
   
       
}}