﻿using System.Linq;

namespace ArtifactsParser
{
    public class Reader
    {
        private string text;

        private int index = 0;

        public Reader(string text)
        {
            this.text = text;
        }

        public char? Peek()
        {
            return this.index < this.text.Count() ? this.text[this.index] : new char?();
        }

        public char? Get()
        {
            char? peek = this.Peek();
            if (peek != null)
            {
                ++this.index;
            }
            return peek;
        }

        public void SkipWhiteSpace()
        {
            while (this.Peek().HasValue && char.IsWhiteSpace(this.Peek().Value))
            {
                this.Get();
            }
        }

        public void Rewind(int count)
        {
            this.index -= count;
            if (this.index < 0)
            {
                this.index = 0;
            }
        }
    }
}
