﻿using System;
using System.Linq;
using TraceLabSDK.Types;

namespace ArtifactsParser.Sentences
{
    public class ParsingStrategy : IParsingStrategy
    {
        public ParsingStrategy() { }

        public TLArtifactsCollection GetArtifacts(string text)
        {
            var collection = new TLArtifactsCollection();
            var sentences = text.Split(new char[] { '.', '?', '!' }, StringSplitOptions.RemoveEmptyEntries);
            var trimmedSentences = sentences.Select(sentence => sentence.Trim());
            var artifacts = trimmedSentences.Select((sentence, i) => new TLArtifact(i.ToString(), sentence)).ToList();
            artifacts.ForEach(artifact => collection.Add(artifact));
            return collection;
        }
    }
}
