﻿using BulletsParser;
using System.ComponentModel;
using TraceLabSDK.Component.Config;

namespace CombinedPolicyParser
{
    public enum ParseOptions
    {
        HeadingAndSection,
        Sentence,
        BulletedList
    }

    public class CombinedPolicyParserConfiguration
    {
        [DisplayName("Parse by")]
        [Description("Choose among 3 parsing options")]
        public ParseOptions ParseOptions { get; set; }

        [DisplayName("Artifacts location")]
        [Description("Location of artifacts file")]
        public FilePath Artifacts { get; set; }

        [DisplayName("Delimiter")]
        [Description("Set delimiter between number/bullet and text. e.g. '.' or ','")]
        public string Delimiter { get; set; }

        [DisplayName("Level 1 bullet format")]
        [Description("Set level 1 bulleting format as 'numbers', 'letters', or 'roman numerals'")]
        public BulletType BulletTypeLevel1 { get; set; }

        [DisplayName("Level 2 bullet format")]
        [Description("Set level 2 bulleting format as 'numbers', 'letters', or 'roman numerals'")]
        public BulletType BulletTypeLevel2 { get; set; }

        [DisplayName("Output Directory")]
        [Description("Directory for output files")]
        public DirectoryPath OutputDirectory { get; set; }
    }
}
