﻿using System.IO.Abstractions;

namespace Common
{
    /// <summary>
    /// A TraceLab configuration for components that interact with the filesystem.
    /// Good for testing purposes.
    /// </summary>
    public abstract class FileSystemConfiguration
    {
        public FileSystemConfiguration() : this(new FileSystem()) { }

        public FileSystemConfiguration(IFileSystem fileSystem)
        {
            this.FileSystem = fileSystem;
        }

        public IFileSystem FileSystem { get; set; }
    }
}
