﻿/*
 * Parse a .drl file by finding which rules are in the file and treating the rule content as bag of words (for now)
 * Builds a list of parsed rules
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;s
using System.Diagnostics;
using System.Text.RegularExpressions;
using System.Collections;

namespace DroolsRulesParser
{
    class Program
    {
        static void Main(string[] args)
        {
            string inputfile = @"..\..\compromisedNode.drl";
            string[] lines = File.ReadAllLines(inputfile);
            List<string> parsed_rules_str = get_items(lines);
            foreach (string s in parsed_rules_str)
            {
                Console.WriteLine(s);
            }
        } // End Main()

        public static List<string> get_items(string[] lines)
        {
            List<string> rule_names = new List<string>();
            List<Rule> parsed_rules = new List<Rule>();
            List<string> rule_content = new List<string>();
            List<string> parsed_rules_str = new List<string>();

            int num_rules = 0;
            foreach (string s in lines)
            {
                Regex rx = new Regex("rule \"(.*)\"", RegexOptions.Compiled);
                Console.WriteLine("\nline:" + s);
                MatchCollection matches = rx.Matches(s);
                Console.WriteLine("Match count:" + matches.Count);
                if (matches.Count > 0)
                {
                    foreach (Match m in matches)
                    {
                        if (num_rules > 0)
                        {
                            parsed_rules[parsed_rules.Count - 1].add_content(rule_content);
                        }
                        string matched_name = m.Groups[1].Value;
                        Console.WriteLine("match:" + matched_name);
                        rule_names.Add(matched_name);
                        // Reset for new rule
                        parsed_rules.Add(new Rule(matched_name));
                        rule_content = new List<string>();
                        num_rules = num_rules + 1;
                    }
                }
                rule_content.Add(s);
            }
            // Ensure last item's content is added correctly
            parsed_rules[parsed_rules.Count - 1].add_content(rule_content);
            Console.WriteLine("\nRules found:");
            foreach (string r in rule_names)
            {
                Console.WriteLine(r);
            }
            Console.WriteLine("\nRules objects:");
            int i = 1;
            foreach (Rule r in parsed_rules)
            {
                r.display();
                string outfile = @"..\..\Rule" + i + ".txt";
                System.IO.File.WriteAllText(outfile, r.parsed_content_str);
                i = i + 1;
                // Transfer rule object's content to add to list of string rules
                parsed_rules_str.Add(r.parsed_content_str);
            }
            Console.WriteLine("\nRules objects as strings:");
            return parsed_rules_str;
        }

    } // Program class
}
