﻿using System;
using System.Collections.Generic;

namespace DroolsRulesParser
{
    class DroolsRule
    {
        public string name;

        public List<string> rawContent = new List<string>();

        public List<string> parsedContent = new List<string>();

        public string parsedContentString;

        public DroolsRule(string name)
        {
            this.name = name;
        }

        public void Display()
        {
            Console.WriteLine("\n\nRule name:" + this.name);
            Console.WriteLine("Rule content (raw):");
            foreach (var s in this.rawContent)
            {
                Console.WriteLine(s);
            }
            Console.WriteLine("Rule content (parsed, as list):");
            foreach (var s in this.parsedContent)
            {
                Console.Write(s + ",");
            }
            Console.WriteLine("\nRule content (parsed, as string):" + this.parsedContentString);
        }

        public void AddContent(List<string> lines)
        {
            var allWords = new List<string>();
            foreach (var line in lines)
            {
                var splitLine = line.Split(new char[] { '{', '}', '&', '!', '*', '\r', '=', ':', '\n', ' ', '.', ',', '+', '(', ')', '$', ';', '\"' });
                foreach (var s in splitLine)
                {
                    if (s != "")
                    {
                        allWords.Add(s);
                        this.parsedContentString = this.parsedContentString + s + ", ";
                    }
                }
            }
            this.parsedContent = allWords;
        }
    }
}
