﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using Moq;
using System.Collections.Generic;
using TraceLabSDK;

namespace HeadingSectionSplitter.Tests
{
    [TestClass]
    public class HeadingSectionSplitterComponentTests
    {
        private HeadingSectionSplitterComponent component;

        private IDictionary<string, object> workspace;

        [TestInitialize]
        public void TestInitialize()
        {
            var logger = new Mock<ComponentLogger>();
            this.component = new HeadingSectionSplitterComponent(logger.Object);

            var workspace = new Mock<IWorkspace>();
            this.workspace = new Dictionary<string, object>();
            workspace.Setup(mock => mock.Load(It.IsAny<string>()))
                .Returns<string>(str => this.workspace[str]);
            workspace.Setup(mock => mock.Store(It.IsAny<string>(), It.IsAny<object>()))
                .Callback<string, object>((str, obj) => this.workspace[str] = obj);
            this.component.Workspace = workspace.Object;
        }

        [TestMethod]
        public void TestConfigurationIsCustomType()
        {
            Assert.IsInstanceOfType(this.component.Configuration, typeof(HeadingSectionSplitterConfiguration));
        }
    }
}
