﻿using System.Windows.Forms;
using TraceLabSDK;

namespace InformedConsent
{
    [Component(
        Name = "Informed Consent",
        Description = "Takes the user through the IRB informed consent process step-by-step, then receives their consent before continuing.",
        Author = "Jared Payne",
        Version = "1.0"
    )]
    public class InformedConsentComponent : BaseComponent
    {
        public InformedConsentComponent(ComponentLogger log) : base(log) { }

        public override void Compute()
        {
            using (var form = new InformedConsentForm())
            {
                if (form.ShowDialog() != DialogResult.OK)
                {
                    throw new ComponentException("User has not given consent to proceed.");
                }
            }
        }
    }
}
