﻿using System;
using System.Linq;
using System.Windows.Forms;

namespace InformedConsent
{
    public partial class InformedConsentForm : Form
    {
        private int currentIndex;

        private InformedConsentModel model = new InformedConsentModel();

        public InformedConsentForm()
        {
            this.InitializeComponent();
            this.CurrentIndex = 0;
        }

        private int CurrentIndex
        {
            get => this.currentIndex;
            set
            {
                this.currentIndex = value;

                var section = this.model.Sections.ElementAt(this.currentIndex);
                this.titleLabel.Text = section.Title;
                this.bodyTextBox.Text = section.Body;
                this.progressLabel.Text = string.Format("{0}/{1}", this.CurrentIndex + 1, this.model.Sections.Count());

                this.previousButton.Enabled = this.currentIndex != 0;
                this.nextButton.Enabled = this.currentIndex != this.model.Sections.Count() - 1;
                this.agreeButton.Enabled = !this.nextButton.Enabled;
            }
        }

        private void previousButton_Click(object sender, EventArgs e)
        {
            --this.CurrentIndex;
        }

        private void nextButton_Click(object sender, EventArgs e)
        {
            ++this.CurrentIndex;
        }

        private void declineButton_Click(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.Cancel;
            base.Close();
        }

        private void agreeButton_Click(object sender, EventArgs e)
        {
            using (var form = new ParticipantInformationForm())
            {
                if (form.ShowDialog() == DialogResult.OK)
                {
                    base.DialogResult = DialogResult.OK;
                    base.Close();
                }
            }
        }
    }
}
