﻿using System.Collections.Generic;

namespace InformedConsent
{
    public class InformedConsentModel
    {
        public class Section
        {
            public string Title { get; set; }

            public string Body { get; set; }
        }

        public IEnumerable<Section> Sections => new Section[]
        {
            new Section
            {
                Title = "WHY ARE YOU BEING INVITED TO TAKE PART IN THIS RESEARCH?",
                Body = "You are being invited to take part in a research study about trace sets.  You are being invited to participate in this research study because you learned about requirements development in software engineering courses at University of Kentucky.   It is your choice whether or not you volunteer for this study.  If you choose not to participate, there will not be any ramifications and you will have the opportunity to perform a different extra credit project of equal value and equal difficulty.  If you take part in this study, you will be one of about 50 people to do so."
            },
            new Section
            {
                Title = "WHO IS DOING THE STUDY?",
                Body = "The person in charge of this study is Dr. Jane Hayes, Professor of Computer Science at the University of Kentucky in Lexington, Kentucky.  There may be other people on the research team assisting at different times during the study."
            },
            new Section
            {
                Title = "WHAT IS THE PURPOSE OF THIS STUDY?",
                Body = "By doing this study, we hope to obtain information about analyst decision making when working with computer-generated trace sets."
            },
            new Section
            {
                Title = "ARE THERE REASONS WHY YOU SHOULD NOT TAKE PART IN THIS STUDY?",
                Body = "We will protect your identity.  Only Dr. Hayes will know what analyst worked on a specific trace set.  We are not aware of any dangers or other risks of which we need to make you aware."
            },
            new Section
            {
                Title = "WHERE IS THE STUDY GOING TO TAKE PLACE AND HOW LONG WILL IT LAST?",
                Body = "The research procedures will be conducted during a portion of a class period and on your own time.  The total amount of time you will be asked to volunteer for this study is approximately three hours over two weeks."
            },
            new Section
            {
                Title = "WHAT WILL YOU BE ASKED TO DO?",
                Body = "You will be performing a tracing task using a traceability tool.  We will work with you two different times.  Specifically, we will explain tracing to you, we will ask you to complete a short questionnaire, we will train you how to use the tracing tool, we will give you a very small sample tracing task, and we will ask you to complete another small questionnaire.  We will use the data from your questionnaires and the data that we capture on your tracing task to further our research. We anticipate that this will take no more than one hour.  At a later time, you will be given a tracing task and will be asked to complete the task at your own pace.  We anticipate that performing the task will not take longer than two hours."
            },
            new Section
            {
                Title = "WHAT ARE THE POSSIBLE RISKS AND DISCOMFORTS?",
                Body = "To the best of our knowledge, the things you will be doing have no more risk of harm than you would experience in everyday life."
            },
            new Section
            {
                Title = "WILL YOU BENEFIT FROM TAKING PART IN THIS STUDY?",
                Body = "As a participant in this study you will receive 1% extra credit in your Software Engineering course.  You will not receive any payment for taking part in this study."
            },
            new Section
            {
                Title = "DO YOU HAVE TO TAKE PART IN THIS STUDY?",
                Body = "If you decide to take part in the study, it should be because you really want to volunteer.  You will not lose any benefits or rights you would normally have if you choose not to volunteer.  If you choose not to volunteer, nobody will be notified or made aware of your choice.  Only the researchers will be aware of your choice, and they will keep this information confidential.  You can stop at any time during the study and still keep the benefits and rights you had before volunteering."
            },
            new Section
            {
                Title = "IF YOU DON’T WANT TO TAKE PART IN THE STUDY, ARE THERE OTHER CHOICES?",
                Body = "If you do not want to be in the study, you may choose to undertake a different extra credit opportunity of equal value and equal difficulty, or you may choose not to undertake any extra credit projects."
            },
            new Section
            {
                Title = "WHAT WILL IT COST YOU TO PARTICIPATE?",
                Body = "There are no costs associated with taking part in this study, except your investments of time and intellect."
            },
            new Section
            {
                Title = "WHO WILL SEE THE INFORMATION THAT YOU GIVE?",
                Body = "When we write up the study to share with other researchers, you will not be identified in these written materials.  However, there are some circumstances in which we may have to show your information to other people.  For example, we may be required to show information which identifies you to people who need to be sure we have done the research correctly; these would be people from such organizations as the Office of Research Integrity at the University of Kentucky.\n\nWe will make every effort to prevent anyone who is not on the research team from knowing that you gave us information, or what that information is.  For example, your name will be kept separate from the information you give, and these two things will be stored in different places under lock and key."
            },
            new Section
            {
                Title = "CAN YOUR TAKING PART IN THE STUDY END EARLY?",
                Body = "If you decide to take part in the study, you still have the right to decide at any time that you no longer want to continue.  You will not be treated differently if you decide to stop taking part in the study."
            },
            new Section
            {
                Title = "WHAT IF YOU HAVE QUESTIONS, SUGGESTIONS, CONCERNS, OR COMPLAINTS?",
                Body = "Before you decide whether to accept this invitation to take part in the study, please ask any questions that might come to mind now.  Later, if you have questions about the study, you can contact the investigator, Dr. Jane Hayes, Professor in the Computer Science Department of University of Kentucky at 859-257-3171.  If you have any questions about your rights as a research volunteer or if you want to register a complaint or a compliment, contact the staff in the Office of Research Integrity at the University of Kentucky at 859-257-9428 or toll free at 1-866-400-9428.  We will give you a copy of this consent form."
            }
        };
    }
}
