﻿using System;
using System.IO;
using System.Linq;
using System.Windows.Forms;

namespace InformedConsent
{
    public partial class ParticipantInformationForm : Form
    {
        public ParticipantInformationForm()
        {
            this.InitializeComponent();
        }

        private void nameTextBox_TextChanged(object sender, EventArgs e)
        {
            this.agreeButton.Enabled = this.nameTextBox.Text.Any();
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.Cancel;
            base.Close();
        }

        private void agreeButton_Click(object sender, EventArgs e)
        {
            var documents = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            var consents = Path.Combine(documents, "InformedConsent");
            Directory.CreateDirectory(consents);

            var time = DateTime.UtcNow;
            var name = this.nameTextBox.Text;
            var filepath = Path.Combine(consents, time.ToString("yyyy-MM-dd-hhmmss") + ".log");
            var contents = string.Format("{0} expressed consent at {1} UTC.", name, time.ToString());
            File.WriteAllText(filepath, contents);
         
            base.DialogResult = DialogResult.OK;
            base.Close();
        }
    }
}
