package components;

import cli.TraceLabSDK.*;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

@ComponentAttribute.Annotation(
        Name = "Parse Users",
        Description = "Parse users.json",
        Author = "Gabbi",
        Version = "1.0",
        ConfigurationType=Config.class)

@IOSpecAttribute.Annotation.__Multiple({
        
})

@TagAttribute.Annotation("Parser")

public class ParseUsers extends BaseComponent {
    
    private final Config config;
    
    public ParseUsers(ComponentLogger log) {
        super(log);
        config = new Config();
        super.set_Configuration(config);
    }
    
    @Override
    public void Compute() {
        
        String inputFile = config.getInputFile();
        
        try {
            
            JSONParser parser = new JSONParser();
            Object obj = parser.parse(new FileReader(inputFile));
            JSONObject jsonobj = (JSONObject) obj;
            JSONArray userEntry = (JSONArray)  ((JSONObject) jsonobj.get("users")).get("user-entry");
            
            
            for(int i=0; i<userEntry.size(); i++){
                JSONObject newobj = (JSONObject) userEntry.get(i);
                String ip = (String) newobj.get("ip");
                String mac = (String) newobj.get("mac");
                Long zoneId = (Long) newobj.get("zone-id");
                String name = (String) newobj.get("name");
                String apIp = (String) newobj.get("ap-ip");
                
                
                
                super.get_Logger().Info("User: " + (i+1));
                super.get_Logger().Info("   ip: " + ip);
                super.get_Logger().Info("   mac: " + mac);
                super.get_Logger().Info("   zone-id: " + zoneId);
                super.get_Logger().Info("   name: " + name);
                super.get_Logger().Info("   ap-ip: " + apIp);
                
                
                
            }

        
    }
        
        catch(FileNotFoundException e){
            super.get_Logger().Info(e);
        }
        
        catch(IOException e){
            super.get_Logger().Info(e);
        }
        
         catch(ParseException e){
            super.get_Logger().Info(e);
        }
}
}
