package components;

import cli.TraceLabSDK.*;
import cli.TraceLabSDK.Types.Generics.Collections.StringList;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.Arrays;
import java.io.File;
import java.io.FileNotFoundException;

@ComponentAttribute.Annotation(
        Name = "Read Integers",
        Description = "Reads integers from text file ",
        Author = "Gabbi",
        Version = "1.0",
        ConfigurationType = Config.class)

@IOSpecAttribute.Annotation.__Multiple({
    @IOSpecAttribute.Annotation(IOType = IOSpecType.__Enum.Output, Name = "Contents",
            DataType = StringList.class)
        
})

@TagAttribute.Annotation("File Reader")

public class ReadInts extends BaseComponent {
     private final Config config;
    public ReadInts(ComponentLogger log) {
        super(log);
        config = new Config();
        super.set_Configuration(config);
    }
    
    @Override
    public void Compute() {
        super.get_Logger().Trace("Beginning file reader");
        String inputFile = config.getInputFile();
        
       try{
        Scanner scanner = new Scanner(new File(inputFile));
        
        List<Integer> intData = new ArrayList<Integer>();
        
        while(scanner.hasNextInt()){
            intData.add(scanner.nextInt());
        }
        
        super.get_Logger().Info(intData);
        super.get_Workspace().Store("Contents", intData); //Store contents of inData in workspace
        
        
       }
       
       catch(FileNotFoundException exception){
           System.out.println(exception);
       }                                                                                                                                                                                                                                                                                                                                                                  
   
       
}}