﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace SimilarityMatrixFilter.Tests
{
    [TestClass]
    public class SimilarityMatrixFilterConfigurationTests
    {
        private SimilarityMatrixFilterConfiguration configuration;

        [TestInitialize]
        public void TestInitialize()
        {
            this.configuration = new SimilarityMatrixFilterConfiguration();
        }

        [TestMethod]
        public void TestConfigurationIsCustomType()
        {
            Assert.IsInstanceOfType(this.configuration, typeof(SimilarityMatrixFilterConfiguration));
        }

        [TestMethod]
        public void TestThresholdDefaultValueIsTenPercent()
        {
            Assert.AreEqual(0.1, this.configuration.Threshold);
        }

        [TestMethod]
        public void TestThrowsArgumentExceptionWhenThresholdIsLessThanZero()
        {
            Assert.ThrowsException<ArgumentException>(() => this.configuration.Threshold = -0.1);
        }

        [TestMethod]
        public void TestThrowsArgumentExceptionWhenThresholdIsGreaterThanOne()
        {
            Assert.ThrowsException<ArgumentException>(() => this.configuration.Threshold = 1.1);
        }
    }
}
