﻿using System;
using System.ComponentModel;

namespace SimilarityMatrixFilter
{
    public class SimilarityMatrixFilterConfiguration
    {
        private double threshold = 0.1;

        [DisplayName("Threshold")]
        [Description("Will filter out links with a score below this value.")]
        [DefaultValue(0.1)]
        public double Threshold
        {
            get => this.threshold;
            set
            {
                if (value < 0.0 || value > 1.0)
                {
                    throw new ArgumentException("Threshold must be between 0.0 and 1.0.");
                }
                this.threshold = value;
            }
        }
    }
}
