package components;

import cli.TraceLabSDK.*;
import java.util.Scanner;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

@ComponentAttribute.Annotation(
        Name = "Sum Columns",
        Description = "Sums the columns of the  integers of a text file, and saves the values to a new txt file",
        Author = "Gabbi",
        Version = "1.0",
        ConfigurationType=Config.class)

@IOSpecAttribute.Annotation.__Multiple({
    @IOSpecAttribute.Annotation(IOType = IOSpecType.__Enum.Output, Name = "Contents",
            DataType = ArrayList.class)
        
})

@TagAttribute.Annotation("File Reader")

public class SumColumns extends BaseComponent {
    
    private final Config config;
    
    public SumColumns(ComponentLogger log) {
        super(log);
        config = new Config();
        super.set_Configuration(config);
    }
    
    @Override
    public void Compute() {
      List<Integer> Sums = new ArrayList<Integer>();
     
      String inputFile = config.getInputFile();
      String outputFile = config.getOutputFile();
      
      try{  
        Scanner scanner = new Scanner(new File(inputFile));
        PrintWriter pw = new PrintWriter(outputFile);
        
        while(scanner.hasNextLine()){
            Scanner line = new Scanner(scanner.nextLine());
            int column = 0;
            
            while(line.hasNextInt()){
               if(column>=Sums.size()){ //Make sums and columns the same size 
                        Sums.add(0);
                }
            
            
            Sums.set(column, Sums.get(column) + line.nextInt());
            column++;
            
            }
        }
        
        
        super.get_Workspace().Store("Contents", Sums); //Print Sums to workspace
        pw.println(Sums);   //Print Sums to output file
        pw.close();         //Close the output file
      }
      
      catch(FileNotFoundException exception){
          super.get_Logger().Info(exception);
      }
      
      }
}
