package components;

//add imports
import cli.TraceLabSDK.*;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

@ComponentAttribute.Annotation(
        Name = "TestRows",
        Description = "Test the output of CSV_Rows by writing output to a file.",
        Author = "sarah",
        Version = "1.0",
        ConfigurationType = config.class)
@IOSpecAttribute.Annotation.__Multiple({
    @IOSpecAttribute.Annotation(IOType = IOSpecType.__Enum.Input, Name = "contents",
            DataType = ArrayList.class, Description = "Optional description for the tooltip"),
    @IOSpecAttribute.Annotation(IOType = IOSpecType.__Enum.Output, Name = "printed_contents",
            DataType = String.class, Description = "Optional description for the tooltip")
})
public class TestRows extends BaseComponent {

    private final config configFile;
    static ArrayList<ArrayList<String>> temp = new ArrayList<>();

    public TestRows(ComponentLogger log) {
        super(log);
        configFile = new config();
        super.set_Configuration(configFile);
    }

    @Override
    public void Compute() {
        super.get_Logger().Trace("TestRows worked!");
        
        //create a string for the output file
        String out_fileName = configFile.getOutputFile();
        
        //create a String to store the output of CsvWriter()
        String output = null;

        //store the contents of the workspace into the ArrayList of ArrayLists - temp
        temp = (ArrayList<ArrayList<String>>) super.get_Workspace().Load("contents");

        //store the output of CsvWriter() in output
        try {
            output = CsvWriter(out_fileName);
        } catch (IOException ex) {
            Logger.getLogger(TestRows.class.getName()).log(Level.SEVERE, null, ex);
        }

        //store the output of CsvWriter() in the workspace
        super.get_Workspace().Store("printed_contents", output);
    }

        /**
     * @param outputFile
     * @return
     * @throws java.io.FileNotFoundException
     */
    public static String CsvWriter(String outputFile) throws FileNotFoundException, IOException {
        
        //create instance of FileWriter to be able to write data out to another file
        FileWriter fw = new FileWriter(outputFile);
        
        //write data out to file
        BufferedWriter bw = new BufferedWriter(fw);
        bw.append("TestRows test");
        for (ArrayList<String> als : temp) {
            int count = 0;
            for (String s : als) {
                if (count == 0) {
                    bw.append(s + ": ");
                } else if (count > 1) {
                    bw.append(", ");
                }
                if (count > 0) {
                    bw.append(s);
                }
                count++;
            } // END, for (item in ArrayList of the column)
            bw.append("\r\n");
        } // END, for (ArrayList of columns)
        bw.append("\r\n");
        
        //return "Well done." to workspace
        return ("Well done.");
    } // END, CsvWriter()
} // END, class
